freeslot(
	"SPR_SEAR",
	"SPR_HEAD",
	"SPR_DSPK",
	"SPR_HAND",
	"SPR_BODY",
	"SPR_SLEG",
	"SPR_FOOT",
	
	"S_SONICBODYPART",
	"S_SONICBODYPART_PAPER",
	"MT_SONICBODYPART"
)

mobjinfo[MT_SONICBODYPART] = {
	doomednum = -1,
	spawnstate = S_SONICBODYPART,
	spawnhealth = 9999,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

states[S_SONICBODYPART] = {SPR_NULL,A,-1,nil,0,0,S_NULL}
states[S_SONICBODYPART_PAPER] = {SPR_NULL,A|FF_PAPERSPRITE,-1,nil,0,0,S_NULL}

local numtopart = {
	[1] = "earr",[6] = "handl",[11] = "footr",[16] = "spiker1",
	[2] = "earl",[7] = "body",[12] = "footl",[17] = "spiker2",
	[3] = "head",[8] = "tummy",[13] = "spikem1",[18] = "spiker3",
	[4] = "face",[9] = "legr",[14] = "spikem2",[19] = "spikel1",
	[5] = "handr",[10] = "legl",[15] = "spikem3",[20] = "spikel2",
	[21] = "spikel3",[22] = "spikem4"
}

local papercut = {
	[1] = true,[2] = true,[4] = true,
	[13] = true,[14] = true,[15] = true,
	[16] = true,[17] = true,[18] = true,
	[19] = true,[20] = true,[21] = true,
	[8] = true,[22] = true,
	[9] = true,[10] = true,
	[11] = true,[12] = true,
}

local itospr = {
	[1] = SPR_SEAR,[7] = SPR_BODY,[12] = SPR_FOOT,[17] = SPR_DSPK,
	[2] = SPR_SEAR,[8] = SPR_BODY,[13] = SPR_DSPK,[18] = SPR_DSPK,
	[3] = SPR_HEAD,[9] = SPR_SLEG,[14] = SPR_DSPK,[19] = SPR_DSPK,
	[4] = SPR_HEAD,[10] = SPR_SLEG,[15] = SPR_DSPK,[20] = SPR_DSPK,
	[5] = SPR_HAND,[11] = SPR_FOOT,[16] = SPR_DSPK,[21] = SPR_DSPK,
	[6] = SPR_HAND,[22] = SPR_DSPK
}

//Sonic
--1     2
--   3
--   4
--5     6
--   7
--   8
--  9 10
--11    12


//Spikes
--    13
--17  14  16
--19  15  18
--21      20

addHook("PlayerSpawn", function(player)
	if player.valid
	and player.mo and player.mo.valid
	and player.mo.skin == "threesonic"
		player.threedsonkick = nil
	end
end)

addHook("SpinSpecial",function(player) --No spindash >:(
	if player.valid
	and player.mo and player.mo.valid
	and player.mo.skin == "threesonic"
		local mo = player.mo
		
		local canstand = (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS) or abs(player.mo.standingslope.zdelta) < FRACUNIT/2)
		if canstand and player.speed < FixedMul(5<<FRACBITS,mo.scale)
		and not mo.momz and P_IsObjectOnGround(mo)
			return true
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid
	and player.mo and player.mo.valid
	and player.mo.skin == "threesonic"
		local mo = player.mo
		
		local SC = mo.scale/2
		local x = mo.x
		local y = mo.y
		local z = mo.z
		local h = 48*SC
		local r = 16*SC
		local c = z+h/2
		local t = c+h/2
		local b = c-h/2
		
		if not player.threedsonkick
			player.threedsonkick = {}
			for i = 1,22
				local name = numtopart[i]
				player.threedsonkick[i] = P_SpawnMobjFromMobj(mo,0,0,0,MT_SONICBODYPART)
				local p = player.threedsonkick[i]
				p.name = name
				p.fuse = 3
				p.scale = SC
				if papercut[i] then p.state = S_SONICBODYPART_PAPER end
				if itospr[i] then p.sprite = itospr[i] end
			end
		else
			local sd = player.threedsonkick
			for i = 1,22
				if player.threedsonkick[i]
					local p = player.threedsonkick
					p[i].scale = mo.scale
					p[i].color = mo.color
					p[i].fuse = 3
					p[i].scale = SC
					p[i].momx = mo.momx
					p[i].momy = mo.momy
					p[i].momz = mo.momz
					if mo.flags2 & MF2_DONTDRAW
						p[i].flags2 = $|MF2_DONTDRAW
					else
						p[i].flags2 = $&~MF2_DONTDRAW
					end
					if (mo.state == S_PLAY_ROLL
					or mo.state == S_PLAY_JUMP
					or mo.state == S_PLAY_SPINDASH)
					and i != 3
						p[i].flags2 = $|MF2_DONTDRAW
					end
					if papercut[i] then p[i].state = S_SONICBODYPART_PAPER end
					if itospr[i] then p[i].sprite = itospr[i] end
					
					if i >= 9 and i <= 10
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,
								player.drawangle+ANGLE_45-(ANGLE_90*(i-9)),
								r)+
							P_ReturnThrustX(mo,player.drawangle,-r)
							,y+P_ReturnThrustY(mo,
								player.drawangle+ANGLE_45-(ANGLE_90*(i-9)),
								r)+
							P_ReturnThrustY(mo,player.drawangle,-r)
							,b+16*SC)
						p[i].dispoffset = 1
						p[i].angle = player.drawangle+ANG15-(ANG30*(i-9))
					end
					if i >= 11 and i <= 12
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,
								player.drawangle+ANGLE_90+(ANGLE_180*(i-11)),
								r-2*SC)+
							P_ReturnThrustX(mo,player.drawangle,-r/4)
							,y+P_ReturnThrustY(mo,
								player.drawangle+ANGLE_90+(ANGLE_180*(i-11)),
								r-2*SC)+
							P_ReturnThrustY(mo,player.drawangle,-r/4)
							,b)
						p[i].angle = player.drawangle+ANG15-(ANG30*(i-11))
					end
					if i == 7
						P_MoveOrigin(p[i],x,y,c)
						p[i].frame = B
					elseif i == 8
						P_MoveOrigin(p[i]
							,x+P_ReturnThrustX(mo,player.drawangle,r)
							,y+P_ReturnThrustY(mo,player.drawangle,r)
						,c+(16*SC))
						p[i].angle = player.drawangle+ANGLE_90
					end
					if i == 22
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,player.drawangle,-r/2),
							y+P_ReturnThrustY(mo,player.drawangle,-r/2),
							c+(20*SC))
						p[i].angle = player.drawangle
					end
					
					if i == 3
						if (mo.state == S_PLAY_ROLL
						or mo.state == S_PLAY_JUMP
						or mo.state == S_PLAY_SPINDASH)
							P_MoveOrigin(p[i],x,y,b)
						else
							P_MoveOrigin(p[i],x,y,t+(14*SC))
						end
						p[i].frame = B
						p[i].dispoffset = 1
					elseif i == 4
						P_MoveOrigin(p[i]
							,x+P_ReturnThrustX(mo,player.drawangle,r*2)
							,y+P_ReturnThrustY(mo,player.drawangle,r*2)
						,t+(22*SC))
						p[i].angle = player.drawangle+ANGLE_90
					end
					
					if i >= 5 and i <= 6
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,
								player.drawangle+ANGLE_45-(ANGLE_90*(i-5)),
								r*2)+
							P_ReturnThrustX(mo,player.drawangle,-r/2)
							,y+P_ReturnThrustY(mo,
								player.drawangle+ANGLE_45-(ANGLE_90*(i-5)),
								r*2)+
							P_ReturnThrustY(mo,player.drawangle,-r/2)
							,c)
						p[i].angle = player.drawangle+ANG15-(ANG30*(i-5))
					end
					if i >= 1 and i <= 2
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,
								player.drawangle+ANGLE_90-(ANGLE_180*(i-1)),
								r),
							y+P_ReturnThrustY(mo,
								player.drawangle+ANGLE_90-(ANGLE_180*(i-1)),
								r),t+(64*SC))
						p[i].angle = player.drawangle+ANGLE_90-ANG2-(2*(ANGLE_90-ANG2)*(i-1))
					end
					
					if i >= 13 and i <= 15
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,player.drawangle,-3*r/2),
							y+P_ReturnThrustY(mo,player.drawangle,-3*r/2),
							t+((i-12)*20*SC))
						p[i].frame = ($&~FF_FRAMEMASK)|(i-13)
						p[i].angle = player.drawangle
					end
					if i >= 16 and i <= 18
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,player.drawangle+ANGLE_45,-3*r/2),
							y+P_ReturnThrustY(mo,player.drawangle+ANGLE_45,-3*r/2),
							t-2*SC+((i-15)*18*SC))
						p[i].frame = ($&~FF_FRAMEMASK)|(i-16)
						p[i].angle = player.drawangle+ANG15/3
					end
					if i >= 19 and i <= 21
						P_MoveOrigin(p[i],
							x+P_ReturnThrustX(mo,player.drawangle-ANGLE_45,-3*r/2),
							y+P_ReturnThrustY(mo,player.drawangle-ANGLE_45,-3*r/2),
							t-2*SC+((i-18)*18*SC))
						p[i].frame = ($&~FF_FRAMEMASK)|(i-19)
						p[i].angle = player.drawangle-ANG15/3
					end
					
					if i >= 13 and i <= 22
						if player.powers[pw_super]
							p[i].renderflags = $|RF_VERTICALFLIP
							p[i].spriteyoffset = -18*FRACUNIT
						else
							p[i].renderflags = $&~RF_VERTICALFLIP
							p[i].spriteyoffset = 0
						end
					end
				end
			end
		end
	end
end)

addHook("PlayerCanEnterSpinGaps", function(player)
	if player.valid
	and player.mo and player.mo.valid
	and player.mo.skin == "threesonic"
		return true
	end
end)